Package com.sas.metadata.remote

# Interface Connection

All Superinterfaces:
  `CMetadata`, `ContentLocation`, `DeployedDataPackage`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

All Known Subinterfaces:
  `COMConnection`, `OpenClientConnection`, `SASClientConnection`, `TCPIPConnection`

public interface Connection extends ContentLocation
Represents the information required to connect to a server. It is associated with the deployed component, i.e. server, that can be accessed using the connection information. It may also be associated with the deployed components that can use the connection information to access the server..

Attributes of Connection are:

- `AuthenticationType`
- `CommunicationProtocol`
- `ApplicationProtocol`

Associations of Connection are:

- `Domain`
- `PassthruPassword`
- `Providers`
- `SAPW`
- `DataSources`
- `Source`

## Usage

To create an instance of this Connection, use the `factory` create methods.
Example: create a Connection with name "Connection_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Connection myObject = (Connection) factory.createComplexMetadataObject(objectStore, "Connection_Object", MetadataObjects.CONNECTION, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_DATASOURCES_NAME`
  Constant used for the name of the DataSources association.
  `static final String`
  `ASSOCIATION_DOMAIN_NAME`
  Constant used for the name of the Domain association.
  `static final String`
  `ASSOCIATION_PASSTHRUPASSWORD_NAME`
  Constant used for the name of the PassthruPassword association.
  `static final String`
  `ASSOCIATION_PROVIDERS_NAME`
  Constant used for the name of the Providers association.
  `static final String`
  `ASSOCIATION_SAPW_NAME`
  Constant used for the name of the SAPW association.
  `static final String`
  `ASSOCIATION_SOURCE_NAME`
  Constant used for the name of the Source association.
  `static final String`
  `ATTRIBUTE_APPLICATIONPROTOCOL_NAME`
  Constant used for the name of the ApplicationProtocol attribute.
  `static final String`
  `ATTRIBUTE_AUTHENTICATIONTYPE_NAME`
  Constant used for the name of the AuthenticationType attribute.
  `static final String`
  `ATTRIBUTE_COMMUNICATIONPROTOCOL_NAME`
  Constant used for the name of the CommunicationProtocol attribute.

  ### Fields inherited from interface com.sas.metadata.remote.ContentLocation

  `ASSOCIATION_ASSOCIATEDCONTENTTYPE_NAME, ASSOCIATION_FILEREFS_NAME, ASSOCIATION_REPORTS_NAME, ASSOCIATION_TSASSOCIATEDNAMESPACE_NAME, ASSOCIATION_UNITOFTIMES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.DeployedDataPackage

  `ASSOCIATION_ALIASES_NAME, ASSOCIATION_ALIASFOR_NAME, ASSOCIATION_DEPLOYEDCOMPONENTS_NAME, ASSOCIATION_TABLECOLLECTIONS_NAME, ASSOCIATION_USEDBYPACKAGES_NAME, ASSOCIATION_USINGPACKAGES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getApplicationProtocol()`
  Gets the `String` value of `ApplicationProtocol`
  `int`
  `getApplicationProtocolMaxLength()`
  Gets the maximum length of `ApplicationProtocol`
  `int`
  `getApplicationProtocolState()`
  Gets the Metadata State of `ApplicationProtocol`
  `String`
  `getAuthenticationType()`
  Gets the `String` value of `AuthenticationType`
  `int`
  `getAuthenticationTypeMaxLength()`
  Gets the maximum length of `AuthenticationType`
  `int`
  `getAuthenticationTypeState()`
  Gets the Metadata State of `AuthenticationType`
  `String`
  `getCommunicationProtocol()`
  Gets the `String` value of `CommunicationProtocol`
  `int`
  `getCommunicationProtocolMaxLength()`
  Gets the maximum length of `CommunicationProtocol`
  `int`
  `getCommunicationProtocolState()`
  Gets the Metadata State of `CommunicationProtocol`
  `AssociationList`
  `getDataSources()`
  Gets the Association list of `DataSources`
  `AssociationList`
  `getDataSources(boolean fGoToServer)`
  Gets the Associationlist of `DataSources`
  `AuthenticationDomain`
  `getDomain()`
  Gets the `AuthenticationDomain` for `Domain`
  `AssociationList`
  `getDomains()`
  Gets the AssociationList of `Domains`
  `AssociationList`
  `getDomains(boolean fGoToServer)`
  Gets the Associationlist of `Domains`
  `SASPassword`
  `getPassthruPassword()`
  Gets the `SASPassword` for `PassthruPassword`
  `AssociationList`
  `getPassthruPasswords()`
  Gets the AssociationList of `PassthruPasswords`
  `AssociationList`
  `getPassthruPasswords(boolean fGoToServer)`
  Gets the Associationlist of `PassthruPasswords`
  `AssociationList`
  `getProviders()`
  Gets the AssociationList of `Providers`
  `AssociationList`
  `getProviders(boolean fGoToServer)`
  Gets the Associationlist of `Providers`
  `SASPassword`
  `getSAPW()`
  Gets the `SASPassword` for `SAPW`
  `AssociationList`
  `getSAPWs()`
  Gets the AssociationList of `SAPWs`
  `AssociationList`
  `getSAPWs(boolean fGoToServer)`
  Gets the Associationlist of `SAPWs`
  `DeployedComponent`
  `getSource()`
  Gets the `DeployedComponent` for `Source`
  `AssociationList`
  `getSources()`
  Gets the Association list of `Sources`
  `AssociationList`
  `getSources(boolean fGoToServer)`
  Gets the Associationlist of `Sources`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `Domain`
  `PassthruPassword`
  `Providers`
  `SAPW`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `Source`
  `void`
  `setApplicationProtocol(String inApplicationProtocol)`
  Sets the `ApplicationProtocol` value and sets the state to MetadataState.LOCAL.
  `void`
  `setApplicationProtocol(String inApplicationProtocol, int state)`
  Sets the `ApplicationProtocol` Metadata State.
  `void`
  `setApplicationProtocolState(int state)`
  Sets the Metadata State of `ApplicationProtocol`.
  `void`
  `setAuthenticationType(String inAuthenticationType)`
  Sets the `AuthenticationType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setAuthenticationType(String inAuthenticationType, int state)`
  Sets the `AuthenticationType` Metadata State.
  `void`
  `setAuthenticationTypeState(int state)`
  Sets the Metadata State of `AuthenticationType`.
  `void`
  `setCommunicationProtocol(String inCommunicationProtocol)`
  Sets the `CommunicationProtocol` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCommunicationProtocol(String inCommunicationProtocol, int state)`
  Sets the `CommunicationProtocol` Metadata State.
  `void`
  `setCommunicationProtocolState(int state)`
  Sets the Metadata State of `CommunicationProtocol`.
  `void`
  `setDataSources(AssociationList list)`
  Sets the `DataSources` list to be `list`.
  `void`
  `setDataSources(AssociationList inObjects, int state)`
  Sets the entire DataSources list to match the passed in AssociationList, sets the state of the DataSources
  `void`
  `setDomain(AuthenticationDomain inObject)`
  Sets the `Domains` list 0th element to be `inObject`.
  `void`
  `setDomains(AssociationList list)`
  Sets the `Domains` list to be `list`.
  `void`
  `setDomains(AssociationList list, int state)`
  Sets the `Domains` list to be `list`.
  `void`
  `setPassthruPassword(SASPassword inObject)`
  Sets the `PassthruPasswords` list 0th element to be `inObject`.
  `void`
  `setPassthruPasswords(AssociationList list)`
  Sets the `PassthruPasswords` list to be `list`.
  `void`
  `setPassthruPasswords(AssociationList list, int state)`
  Sets the `PassthruPasswords` list to be `list`.
  `void`
  `setProviders(AssociationList list)`
  Sets the `Providers` list to be `list`.
  `void`
  `setProviders(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setSAPW(SASPassword inObject)`
  Sets the `SAPWs` list 0th element to be `inObject`.
  `void`
  `setSAPWs(AssociationList list)`
  Sets the `SAPWs` list to be `list`.
  `void`
  `setSAPWs(AssociationList list, int state)`
  Sets the `SAPWs` list to be `list`.
  `void`
  `setSource(DeployedComponent inObject)`
  Sets the `Sources` list 0th element to be `inObject`.
  `void`
  `setSources(AssociationList list)`
  Sets the `Sources` list to be `list`.
  `void`
  `setSources(AssociationList list, int state)`
  Sets the `Sources` list to be `list`.

  ### Methods inherited from interface com.sas.metadata.remote.ContentLocation

  `getAssociatedContentType, getAssociatedContentTypes, getAssociatedContentTypes, getFileRefs, getFileRefs, getReports, getReports, getTSAssociatedNamespace, getTSAssociatedNamespaces, getTSAssociatedNamespaces, getUnitofTimes, getUnitofTimes, setAssociatedContentType, setAssociatedContentTypes, setAssociatedContentTypes, setFileRefs, setFileRefs, setReports, setReports, setTSAssociatedNamespace, setTSAssociatedNamespaces, setTSAssociatedNamespaces, setUnitofTimes, setUnitofTimes`

  ### Methods inherited from interface com.sas.metadata.remote.DeployedDataPackage

  `getAliases, getAliases, getAliasFor, getAliasFors, getAliasFors, getDeployedComponents, getDeployedComponents, getTableCollections, getTableCollections, getUsedByPackages, getUsedByPackages, getUsingPackages, getUsingPackages, setAliases, setAliases, setAliasFor, setAliasFors, setAliasFors, setDeployedComponents, setDeployedComponents, setTableCollections, setTableCollections, setUsedByPackages, setUsedByPackages, setUsingPackages, setUsingPackages`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_AUTHENTICATIONTYPE_NAME

    static final String ATTRIBUTE_AUTHENTICATIONTYPE_NAME
    Constant used for the name of the AuthenticationType attribute.

    AuthenticationType: This attribute indicates the type of authentication needed to connect to this server. It has an enumerated set of values: none user/password password certificate

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_COMMUNICATIONPROTOCOL_NAME

    static final String ATTRIBUTE_COMMUNICATIONPROTOCOL_NAME
    Constant used for the name of the CommunicationProtocol attribute.

    CommunicationProtocol: This attribute indicates the communication protocol: TCP, APPC and any others that may be supported.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_APPLICATIONPROTOCOL_NAME

    static final String ATTRIBUTE_APPLICATIONPROTOCOL_NAME
    Constant used for the name of the ApplicationProtocol attribute.

    ApplicationProtocol: This attribute represents the application level protocol being used on this connection. It can have values like CONNECT, SHARE, Bridge, etc. It allows the list of connections to be queried by the type of usage expected, regardless of communication protocol.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_DOMAIN_NAME

    static final String ASSOCIATION_DOMAIN_NAME
    Constant used for the name of the Domain association.

    Domain: The name of the authorization domain that maintains the user identities and credentials used to connect to the deployed component accessed through this connection object.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_PASSTHRUPASSWORD_NAME

    static final String ASSOCIATION_PASSTHRUPASSWORD_NAME
    Constant used for the name of the PassthruPassword association.

    PassthruPassword: The SAS password to use with the Remote SQL Passthru option PT2DBPW=.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_PROVIDERS_NAME

    static final String ASSOCIATION_PROVIDERS_NAME
    Constant used for the name of the Providers association.

    Providers: The deployed components that can use the connection information to access another component. For example, this is the list of DBMS clients, like a JDBC application, that can use the connection information to access a DBMS.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_SAPW_NAME

    static final String ASSOCIATION_SAPW_NAME
    Constant used for the name of the SAPW association.

    SAPW: The SAS password used for the RLS SASPW= option.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_DATASOURCES_NAME

    static final String ASSOCIATION_DATASOURCES_NAME
    Constant used for the name of the DataSources association.

    DataSources: The data source name that uses this connection.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_SOURCE_NAME

    static final String ASSOCIATION_SOURCE_NAME
    Constant used for the name of the Source association.

    Source: The deployed software component that can be accessed through this connection object.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    `Source`
    Specified by:
      `initializeRequiredObjects` in interface `ContentLocation`
    Specified by:
      `initializeRequiredObjects` in interface `DeployedDataPackage`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `Domain`
    `PassthruPassword`
    `Providers`
    `SAPW`
    Specified by:
      `initializePredObjects` in interface `ContentLocation`
    Specified by:
      `initializePredObjects` in interface `DeployedDataPackage`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAuthenticationType

    String getAuthenticationType() throws RemoteException
    Gets the `String` value of `AuthenticationType`
    Returns:
      The `AuthenticationType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAuthenticationTypeState

    int getAuthenticationTypeState() throws RemoteException
    Gets the Metadata State of `AuthenticationType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAuthenticationTypeMaxLength

    int getAuthenticationTypeMaxLength() throws RemoteException
    Gets the maximum length of `AuthenticationType`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCommunicationProtocol

    String getCommunicationProtocol() throws RemoteException
    Gets the `String` value of `CommunicationProtocol`
    Returns:
      The `CommunicationProtocol`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCommunicationProtocolState

    int getCommunicationProtocolState() throws RemoteException
    Gets the Metadata State of `CommunicationProtocol`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCommunicationProtocolMaxLength

    int getCommunicationProtocolMaxLength() throws RemoteException
    Gets the maximum length of `CommunicationProtocol`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getApplicationProtocol

    String getApplicationProtocol() throws RemoteException
    Gets the `String` value of `ApplicationProtocol`
    Returns:
      The `ApplicationProtocol`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getApplicationProtocolState

    int getApplicationProtocolState() throws RemoteException
    Gets the Metadata State of `ApplicationProtocol`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getApplicationProtocolMaxLength

    int getApplicationProtocolMaxLength() throws RemoteException
    Gets the maximum length of `ApplicationProtocol`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDomains

    AssociationList getDomains() throws RemoteException, MdException
    Gets the AssociationList of `Domains`
    Returns:
      Returns the AssociationList of `Domains` which can be of type:
      AuthenticationDomain
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getDomain

    AuthenticationDomain getDomain() throws RemoteException, MdException
    Gets the `AuthenticationDomain` for `Domain`
    Returns:
      The `AuthenticationDomain` ( `null` if not set) of `Domain`which can be of type:
      AuthenticationDomain
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPassthruPasswords

    AssociationList getPassthruPasswords() throws RemoteException, MdException
    Gets the AssociationList of `PassthruPasswords`
    Returns:
      Returns the AssociationList of `PassthruPasswords` which can be of type:
      SASPassword
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getPassthruPassword

    SASPassword getPassthruPassword() throws RemoteException, MdException
    Gets the `SASPassword` for `PassthruPassword`
    Returns:
      The `SASPassword` ( `null` if not set) of `PassthruPassword`which can be of type:
      SASPassword
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getProviders

    AssociationList getProviders() throws RemoteException, MdException
    Gets the AssociationList of `Providers`
    Returns:
      Returns the AssociationList of `Providers` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSAPWs

    AssociationList getSAPWs() throws RemoteException, MdException
    Gets the AssociationList of `SAPWs`
    Returns:
      Returns the AssociationList of `SAPWs` which can be of type:
      SASPassword
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getSAPW

    SASPassword getSAPW() throws RemoteException, MdException
    Gets the `SASPassword` for `SAPW`
    Returns:
      The `SASPassword` ( `null` if not set) of `SAPW`which can be of type:
      SASPassword
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDataSources

    AssociationList getDataSources() throws RemoteException, MdException
    Gets the Association list of `DataSources`
    Returns:
      The AssociationList of `DataSources` which can be of type:
      DataSourceName
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSources

    AssociationList getSources() throws RemoteException, MdException
    Gets the Association list of `Sources`
    Returns:
      The AssociationList of `Sources` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSource

    DeployedComponent getSource() throws RemoteException, MdException
    Gets the `DeployedComponent` for `Source`
    Returns:
      The `DeployedComponent` ( `null` if not set ) of `Source` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDomains

    AssociationList getDomains(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Domains`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Domains` which can be of type:
      AuthenticationDomain
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPassthruPasswords

    AssociationList getPassthruPasswords(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `PassthruPasswords`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `PassthruPasswords` which can be of type:
      SASPassword
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getProviders

    AssociationList getProviders(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Providers`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Providers` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSAPWs

    AssociationList getSAPWs(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `SAPWs`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `SAPWs` which can be of type:
      SASPassword
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDataSources

    AssociationList getDataSources(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `DataSources`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `DataSources` which can be of type:
      DataSourceName
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSources

    AssociationList getSources(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Sources`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Sources` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setAuthenticationType

    void setAuthenticationType(String inAuthenticationType) throws RemoteException
    Sets the `AuthenticationType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inAuthenticationType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAuthenticationType

    void setAuthenticationType(String inAuthenticationType, int state) throws RemoteException
    Sets the `AuthenticationType` Metadata State.
    Parameters:
      `inAuthenticationType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAuthenticationTypeState

    void setAuthenticationTypeState(int state) throws RemoteException
    Sets the Metadata State of `AuthenticationType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCommunicationProtocol

    void setCommunicationProtocol(String inCommunicationProtocol) throws RemoteException
    Sets the `CommunicationProtocol` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCommunicationProtocol` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCommunicationProtocol

    void setCommunicationProtocol(String inCommunicationProtocol, int state) throws RemoteException
    Sets the `CommunicationProtocol` Metadata State.
    Parameters:
      `inCommunicationProtocol` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCommunicationProtocolState

    void setCommunicationProtocolState(int state) throws RemoteException
    Sets the Metadata State of `CommunicationProtocol`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setApplicationProtocol

    void setApplicationProtocol(String inApplicationProtocol) throws RemoteException
    Sets the `ApplicationProtocol` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inApplicationProtocol` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setApplicationProtocol

    void setApplicationProtocol(String inApplicationProtocol, int state) throws RemoteException
    Sets the `ApplicationProtocol` Metadata State.
    Parameters:
      `inApplicationProtocol` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setApplicationProtocolState

    void setApplicationProtocolState(int state) throws RemoteException
    Sets the Metadata State of `ApplicationProtocol`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDomains

    void setDomains(AssociationList list) throws RemoteException
    Sets the `Domains` list to be `list`. Object of which can be of type:
    AuthenticationDomain
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDomains

    void setDomains(AssociationList list, int state) throws RemoteException
    Sets the `Domains` list to be `list`. Object of which can be of type:
    AuthenticationDomain
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDomain

    void setDomain(AuthenticationDomain inObject) throws RemoteException
    Sets the `Domains` list 0th element to be `inObject`.
    Parameters:
      `inObject` - AuthenticationDomain
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPassthruPasswords

    void setPassthruPasswords(AssociationList list) throws RemoteException
    Sets the `PassthruPasswords` list to be `list`. Object of which can be of type:
    SASPassword
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPassthruPasswords

    void setPassthruPasswords(AssociationList list, int state) throws RemoteException
    Sets the `PassthruPasswords` list to be `list`. Object of which can be of type:
    SASPassword
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPassthruPassword

    void setPassthruPassword(SASPassword inObject) throws RemoteException
    Sets the `PassthruPasswords` list 0th element to be `inObject`.
    Parameters:
      `inObject` - SASPassword
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setProviders

    void setProviders(AssociationList list) throws RemoteException
    Sets the `Providers` list to be `list`. Objects of which can be of type:
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setProviders

    void setProviders(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSAPWs

    void setSAPWs(AssociationList list) throws RemoteException
    Sets the `SAPWs` list to be `list`. Object of which can be of type:
    SASPassword
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSAPWs

    void setSAPWs(AssociationList list, int state) throws RemoteException
    Sets the `SAPWs` list to be `list`. Object of which can be of type:
    SASPassword
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSAPW

    void setSAPW(SASPassword inObject) throws RemoteException
    Sets the `SAPWs` list 0th element to be `inObject`.
    Parameters:
      `inObject` - SASPassword
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDataSources

    void setDataSources(AssociationList list) throws RemoteException
    Sets the `DataSources` list to be `list`. Objects of which can be of type:
    DataSourceName
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDataSources

    void setDataSources(AssociationList inObjects, int state) throws RemoteException
    Sets the entire DataSources list to match the passed in AssociationList, sets the state of the DataSources
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSources

    void setSources(AssociationList list) throws RemoteException
    Sets the `Sources` list to be `list`. Objects of which can be of type:
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSources

    void setSources(AssociationList list, int state) throws RemoteException
    Sets the `Sources` list to be `list`. Objects of which can be of type:
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSource

    void setSource(DeployedComponent inObject) throws RemoteException
    Sets the `Sources` list 0th element to be `inObject`.
    Parameters:
      `inObject` - DeployedComponent
    Throws:
      `RemoteException` - If error communicating with remote object.